#!/bin/sh

bdbsrc=$1
curr_dir=`pwd`

if [ -d old ]; then
	echo "===>Old files have already been backed up before"
	echo "===>So there is no need to backup again this time"
else
	echo "===>Now backup old files in $curr_dir/old"
	echo "===>Create the backup directory"
	rm -rf old
	mkdir old
	
	echo "===>Copy the original files that are going to be changed"
	cp -f ${bdbsrc}/dist/Makefile.in old
	cp -f ${bdbsrc}/include/db.src old
	cp -f ${bdbsrc}/include/region.h old
	cp -f ${bdbsrc}/env/env_open.c old
	cp -f ${bdbsrc}/env/env_recover.c old
	cp -f ${bdbsrc}/db/db.c old
	cp -f ${bdbsrc}/db/db_cam.c old
	cp -f ${bdbsrc}/db/db_ret.c old
        cp -f ${bdbsrc}/db/db_dispatch.c old
	cp -f ${bdbsrc}/mp/mp_bh.c old
	cp -f ${bdbsrc}/mp/mp_fget.c old
        cp -f ${bdbsrc}/mp/mp_fput.c old
        cp -f ${bdbsrc}/mp/mp_sync.c old
	cp -f ${bdbsrc}/txn/txn.c old
	cp -f ${bdbsrc}/btree/bt_put.c old
	cp -f ${bdbsrc}/btree/bt_split.c old
	cp -f ${bdbsrc}/btree/bt_open.c old
	cp -f ${bdbsrc}/btree/bt_rec.c old
	cp -f ${bdbsrc}/db/db_rec.c old
	cp -f ${bdbsrc}/include/db_page.h old
	cp -f ${bdbsrc}/include/db_ext.h old
	cp -f ${bdbsrc}/db/db_overflow.c old
	cp -f ${bdbsrc}/btree/bt_verify.c old
	cp -f ${bdbsrc}/btree/bt_compare.c old
	cp -f ${bdbsrc}/hash/hash.c old
	cp -f ${bdbsrc}/hash/hash_page.c old
	cp -f ${bdbsrc}/db/db_vrfy.c old
	cp -f ${bdbsrc}/hash/hash_verify.c old
	echo "===>Backup finished"
fi

