#!/bin/sh

exe=clkTest1
silent= &> /dev/null

##########################################
# Validation Check
##########################################
if [ $# -ne 3 ]; then
    echo "USAGE: ${0} bdbsrc beeheader_path beelib"
fi

bdbsrc=${1}
beedir=${2}
beelib=${3}
bdbbuild=${bdbsrc}/build_unix

##########################################
# Make 1
##########################################
make prepare ${silent}
make ${exe} BDBSRC=${bdbsrc} BEEHEADER=${beepath} BEELIB=${beelib} ${silent}
if [ $? -ne 0 ]; then
    echo "    make failed"
    make clean ${silent}
    exit 1;
fi

##########################################
# Run the testcase 1
##########################################
echo "Testcase running ..."
./${exe} > tmpout
if [ $? -ne 0 ]; then
    echo "    ${exe} failed"
    make clean ${silent}
    exit 1
fi

##########################################
# Make 2
##########################################
make prepare ${silent}
make ${exe} BDBSRC=${bdbsrc} BEEHEADER=${beepath} BEELIB=${beelib} ${silent}
if [ $? -ne 0 ]; then
    echo "    make failed"
    make clean ${silent}
    exit 1;
fi

##########################################
# Run the testcase 2
##########################################
echo "Testcase running ..."
./${exe} >> tmpout
if [ $? -ne 0 ]; then
    echo "    ${exe} failed"
    make clean ${silent}
    exit 1
fi

##########################################
# Check the result
##########################################
mv -f tmpout tmpout1
sed -e "s/(((.*)))/+++++/" -e "/=====TT=====/,/============/d" tmpout1 > tmpout
# exit

diff expout tmpout ${silent}
if [ $? -ne 0 ]; then
    echo "    ${exe} failed"
    make clean ${silent}
    exit 1
fi

##########################################
# Successful
##########################################
make clean ${silent}
exit 0
