#!/bin/sh

exe=expSetupAlt
silent= &> /dev/null

##########################################
# Validation Check
##########################################
if [ $# -ne 3 ]; then
    echo "USAGE: ${0} bdbsrc beedir"
fi

bdbsrc=${1}
beeheader=${2}
beelib=${3}
bdbbuild=${bdbsrc}/build_unix

##########################################
# Make 1
##########################################
make prepare ${silent}
make ${exe} BDBSRC=${bdbsrc} BEEHEADER=${beeheader} BEELIB=${beelib} ${silent}
if [ $? -ne 0 ]; then
    echo "    make failed"
    make clean ${silent}
    exit 1;
fi

##########################################
# Run the testcase 1
##########################################
echo "Testcase running ..."
./${exe} 3 32
if [ $? -ne 0 ]; then
    echo "    ${exe} failed"
    make clean ${silent}
    exit 1
fi

##########################################
# Successful
##########################################
make clean ${silent}
exit 0
