#ifndef _TTDB_EXT_H_
#define _TTDB_EXT_H_

int __ttdb_put(struct __ttdb *db, DB_TXN *txnid, DBT *key, DBT *data,
        u_int32_t flags);
int __ttdb_get(struct __ttdb *db, DB_TXN *txnid, DBT *key, DBT *data,
        u_int32_t flags);
#ifdef BDB_4
int __ttdb_open(struct __ttdb *ttdb, DB_TXN *tid, const char *file, const char *database,
        DBTYPE type, u_int32_t flags, int mode);
#endif
#ifdef BDB_3
int __ttdb_open(struct __ttdb *ttdb, const char *file, const char *database,
        DBTYPE type, u_int32_t flags, int mode);
#endif

int __ttdb_del(struct __ttdb *db, DB_TXN *txnid, DBT *key, u_int32_t flags);
int __tt_cursor(struct __ttdb*,DB_TXN*, struct __ttdbc**,u_int32_t);
int __ttdb_c_del(TTDBC *dbc_arg, u_int32_t flags);
int __ttdb_c_get(TTDBC *dbc_arg, DBT *key, DBT *data, u_int32_t flags);
int __ttdb_c_put (TTDBC * dbc_arg, DBT *key, DBT *data, u_int32_t flags);
int __ttdb_c_get_nonsequenced(struct __ttdbc *ttdbc, DBT *key, DBT *data, struct
        timeval start, struct timeval stop, u_int32_t flags, struct timeval
        *outstart, struct timeval *outstop);
/* PARTITION Mani - 9th Aug 2003 - Added func decl. to the header file */
int __ttdb_c_get_nonsequenced_internal(struct __dbc *dbCursor, DBT *key, DBT *data,
        struct timeval start, struct timeval stop, u_int32_t flags, struct
        timeval *outstart, struct timeval *outstop);
/* Mani End */
void __ttdb_err(struct __ttdb* ttdb, int err, const char *fmt, ...);

/*int __ttdb_associate(struct __ttdb *primary, struct __ttdb *secondary,
        int (*callback)(struct __db *, const DBT *, const DBT *, DBT *),
        u_int32_t flags);

int __ttdb_fd(struct __ttdb *db, int *fdp);

int __ttdb_get_byteswapped(struct __ttdb *db, int *isswapped);

int __ttdb_get_type(struct __ttdb *db, DBTYPE *type);

int __ttdb_join(struct __ttdb *primary, struct __ttdbc **curslist, DBC **dbcp,
        u_int32_t flags);
*/
void __ttdb_set_errfile(struct __ttdb *db, FILE *errfile);

void __ttdb_set_errpfx(struct __ttdb *db, const char *errpfx);

int __ttdb_set_cachesize(struct __ttdb *db, u_int32_t gbytes, u_int32_t bytes, int
        ncache);

int __ttdb_set_pagesize(struct __ttdb *db, u_int32_t pagesize);

#endif /* _TTDB_EXT_H_ */
