/* Hash value length, number of bytes */
//#define AUD_HASH_LEN 20

/* typedef struct timeval TV; */

/* Sizes */
#define AUD_REG_SIZE 5000000
#define AUD_TOL_SIZE 20000

struct __aud_tol_entry {
    u_int32_t txnid;
    char ready; /* ready to be link-hashed: committed and all tuples hashed */
    TV time; /* before ready: eariest time; after ready: txn time */
    char hash_value[AUD_HASH_LEN]; /* hash value by XOR'ing */
    int seq; /* next available sequence number */
    void *hash_param; /* store the hash function state */
    SH_TAILQ_ENTRY links; /* links for free list */
};
typedef struct __aud_tol_entry AUD_TOL_ENTRY;

/* Per-transaction data to be hashed and put into the hash chain */
/*struct __aud_txn_hash_data {
    char prev_hash_value[AUD_HASH_LEN];
    TV time;
    char hash_value[AUD_HASH_LEN];
};
typedef struct __aud_txn_hash_data AUD_TXN_HASH_DATA;*/

struct __db_aud {
    /*
     * These fields need to be protected for multi-threaded support.
     *
     * !!!
     * As this structure is allocated in per-process memory, the mutex may need
     * to be stored elsewhere on architectures unable to support mutexes in heap
     * memory, e.g., HP/UX 9.
     */
#ifdef BDB_4
    DB_MUTEX
#endif
#ifdef BDB_3
    MUTEX
#endif
    *mutexp; /* Mutex for thread protection. */

    /* These fields are not thread-protected. */
    DB_ENV *dbenv; /* Reference to error information. */
    REGINFO reginfo; /* Underlying cache regions. */
    u_int32_t flags;
};
typedef struct __db_aud DB_AUD;

/*
 * AUD --
 *	Shared stamper region.  One of these is allocated in shared memory,
 *	and describes the stamper.
 */
struct __aud {

    SH_TAILQ_HEAD(__tol) tol; /* TOL head */
    u_int32_t tol_size; /* Max number of entries in the TOL */

    SH_TAILQ_HEAD(__tol_free) free_tol_entries;

    char hash_value[AUD_HASH_LEN]; /* Hash chain tail value */
    TV hash_tail_time; /* The time of the tail transaction we've just hashed */

    int ready_to_hash; /* The chain tail is not pending for the new nID */

#ifdef BDB_4
    DB_MUTEX
#endif
#ifdef BDB_3
    MUTEX
#endif
    flush; /* Mutex for flushing. */

#ifdef MUTEX_SYSTEM_RESOURCES
#define	AUD_MAINT_SIZE	(sizeof(roff_t) * DB_MAX_HANDLES)
    roff_t maint_off; /* offset of region maintenance info */
#endif

    u_int32_t flags; /* Environment-wide flag values. */
};
typedef struct __aud AUD;


struct __aud_history_entry {
    TV tail_txntime;
    TV ntime;
    char nid[AUD_HASH_LEN];
};
typedef struct __aud_history_entry AUD_HISTORY_ENTRY;

/*struct __nid {
    TV ntime;
    char nid[AUD_HASH_LEN];
};
typedef struct __nid NID;*/

