/*
 *  $Id: heap.h,v 1.1 2012-02-16 00:42:19 ruizhang Exp $
 *
 *  See the copyright notice and terms of use in file heap.c.
 */

#ifndef HEAP_H_INCLUDED
#define HEAP_H_INCLUDED

extern char const Heap_rcsid[];

#define T Heap_T
typedef struct T *T;

typedef struct HeapItem_T *HI_T;

typedef enum {
  HEAP_OKAY = 0,        /*  all is well                     */
  HEAP_ERR_OVFL,        /*  insert failed                   */
  HEAP_ERR_BOUNDARY,    /*  internal inconsistency          */
  HEAP_ERR_NOTHEAP,     /*  heap property violated          */
  HEAP_ERR_REF          /*  referential integrity violated  */
} HeapErr_T;

extern T
Heap_new(const int init_size, int cmp(const void *a, const void *b),
         HI_T *(*self)(void *p));

extern HeapErr_T
Heap_insert(T heap, void *p);

void *
Heap_top(const T heap);

void *
Heap_extract_min(T heap);

void
Heap_check(T heap, void func(HeapErr_T err));

int
Heap_size(T heap);

void
Heap_free(T *pheap);

int
Heap_member(const T heap, void *p);

void *
Heap_remove(T heap, void *p);

void
Heap_update(T heap, void *p);

#undef T
#endif
