#include <stdlib.h>

#include "db_config.h"

#include <sys/types.h>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>

/* Original BDB system */
#include "db_int.h"
#include "db_shash.h"
#include "lock.h"
#include "db_page.h"
#include "mp.h"
#include "qam.h"
#include "log.h"

/* TT support */
#include "db.h"
#include "TTDB.h"
#include "clk_txn.h"
#include "stp_int.h"
#include "stp_tt.h"

/* Huilong 7/14/06 */
#ifdef TBDB_AUDIT
#include "../stp/aud_int.h"
#endif
/* end 7/14/06 */

#include "temporal.h"

extern int stp_pause;

int
__temporal_open(DB_ENV *dbenv)
{
    TEMPORAL_HANDLE *th;

    if ((th = malloc(sizeof(TEMPORAL_HANDLE))) == NULL)
	return EINVAL;

    th->stp_handle = NULL;
    th->clk_handler = NULL;

    dbenv->temporal_handle = th;

    STP_EXP( __stp_timereset() );
    STP_EXP( resetcall() );

    return (0);
}

int
__temporal_flag_check(DB_ENV *dbenv, int flags)
{
    if ( (flags&DB_TEMPORAL) &&
	 (((TEMPORAL_HANDLE *)(dbenv->temporal_handle))->stp_handle == NULL) )
	return EINVAL;
    else
	return 0;
}

/*
 * __temporal_partition_flag_check --
 * PARTITION Mani 28th Mar 2003, this check is called bfor any db open/create operation is performed
 * Since we know for sure that we cant have the partitioned db feature for a non temporal db
 * so we must be prevent it right upfront
 */

int __temporal_partition_flag_check(int flags) {

	if ( !(flags & DB_TEMPORAL) && (flags & DB_PARTITION) ) return EINVAL;
	else return 0;

}

/* Mani End */
